#  C1011.defn.tcl

proc {Add_C1011_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]
   set A16addrbase [first $addressinfo]
#   set A24addrbase [second $addressinfo]
#   set A32addrbase [third $addressinfo]
#   set interruptlevel [fourth $addressinfo]
#   set interruptvector [fifth $addressinfo]

   set CurrentVMEServer  $server

   define-vme-register $name xVME mode     "-a$A16addrbase -w16 -o1 -pwo -d8 -zx"
   define-vme-register $name xVME status   "-a$A16addrbase -w16 -o3 -pro -d8 -zx"
   define-vme-register $name xVME control  "-a$A16addrbase -w16 -o3 -pwo -d8 -zx"
   define-vme-register $name xVME vsn      "-a$A16addrbase -w16 -o5 -pwo -d8 -zd"
   define-vme-register $name xVME delay    "-a$A16addrbase -w16 -o7 -pwo -d8 -zd"
}


proc {C1011_DAQ-reset} {args} {
#   C1011
    global CurrentVMEServer EGallow EGreport
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.status] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

proc {C1011_DAQ-go} {args} {
#   C1011
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    enable FERA readout and start
    write-vme-register $module.mode 10
}

proc {C1011_DAQ-halt} {args} {
#   C1011
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#    disable FERA readout and stop
    write-vme-register $module.mode 0
}

proc {C1011_DAQ-setup} {args} {
#   C1011
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
}

#   for parameter save/restore
set {C1011_registersavepatterns} {control vsn delay}


